#
# spec file for package scim (Version 1.0.2)
#
# Copyright (c) 2004 SUSE LINUX Products GmbH, Nuernberg, Germany.
# This file and all modifications and additions to the pristine
# package are under the same license as the package itself.
#
# Please submit bugfixes or comments via http://www.suse.de/feedback/
#

# norootforbuild
# neededforbuild  docbook-xsl-stylesheets doxygen expat gnome2-devel-packages gpp graphviz intltool libgpp libpng libxslt perl-XML-Parser update-desktop-files

BuildRequires: aaa_base acl attr bash bind-utils bison bzip2 coreutils cpio cpp cracklib cvs cyrus-sasl db devs diffutils e2fsprogs file filesystem fillup findutils flex gawk gdbm-devel glibc glibc-devel glibc-locale gpm grep groff gzip info insserv kbd less libacl libattr libgcc libselinux libstdc++ libxcrypt m4 make man mktemp module-init-tools ncurses ncurses-devel net-tools netcfg openldap2-client openssl pam pam-modules patch permissions popt procinfo procps psmisc pwdutils rcs readline sed strace syslogd sysvinit tar tcpd texinfo timezone unzip util-linux vim zlib zlib-devel XFree86-devel XFree86-libs alsa alsa-devel atk atk-devel audiofile autoconf automake binutils docbook-xsl-stylesheets doxygen esound esound-devel expat fontconfig fontconfig-devel freetype2 freetype2-devel gcc gcc-c++ gconf2 gconf2-devel gdbm gettext glib2 glib2-devel gnome-filesystem gnome-keyring gnome-keyring-devel gnome-vfs2 gnome-vfs2-devel graphviz gtk2 gtk2-devel intltool libart_lgpl libart_lgpl-devel libbonobo libbonobo-devel libbonoboui libbonoboui-devel libglade2 libglade2-devel libgnome libgnome-devel libgnomecanvas libgnomecanvas-devel libgnomeprint libgnomeprint-devel libgnomeprintui libgnomeprintui-devel libgnomeui libgnomeui-devel libjpeg libpng libstdc++-devel libtool libwnck libwnck-devel libxml2 libxml2-devel libxslt linc linc-devel openssl-devel orbit2 orbit2-devel pango pango-devel perl perl-XML-Parser pkgconfig popt-devel rpm update-desktop-files

Name:         scim
Summary:      Smart Chinese/Common Input Method platform
Version:      1.0.2
Release:      0.1
License:      LGPL
Group:        System/I18n/Chinese
Autoreqprov:  on
PreReq:       filesystem gconf2 /usr/bin/touch
Obsoletes:    scim-frontend-x11, scim-server-rawcode, scim-config-simple, scim-server-table, scim-gtk2-immodule, scim-config-socket, scim-server-socket, scim-config-gconf, scim-frontend-socket
Provides:     scim-frontend-x11, scim-server-rawcode, scim-config-simple, scim-server-table, scim-gtk2-immodule, scim-config-socket, scim-server-socket, scim-config-gconf, scim-frontend-socket
URL:          http://www.freedesktop.org/~suzhe
# CVS repository:
# cvs -z3 -d:ext:anoncvs@savannah.nongnu.org:/cvsroot/scim co scim-lib
# Source0:      http://freedesktop.org/~suzhe/sources/scim-0.99.7.tar.bz2
Source0:      http://osdn.dl.sourceforge.net/sourceforge/scim/scim-1.0.2.tar.bz2
Patch0:       scim.patch
Patch1:       configs.patch
Patch2:       default-languages.patch
Patch100:     gettextize.patch
BuildRoot:    %{_tmppath}/%{name}-%{version}-build

%description
SCIM is a developing platform to significant reduce the difficulty of
input method development.



Authors:
--------
    James Su <suzhe@tsinghua.org.cn>

%package devel
Summary:      Include Files and Libraries mandatory for Development.
Group:        System/I18n/Chinese
Requires:     %{name} = %{version}
Requires:     pkgconfig >= 0.12

%description devel
This package contains all necessary include files and libraries needed
to develop applications that require these.



Authors:
--------
    James Su <suzhe@tsinghua.org.cn>

%prep
%define build_config_socket	1
%define build_config_gconf	1
%define build_config_simple	1
%define build_frontend_x11	1
%define build_frontend_socket	1
%define build_imengine_rawcode	1
%define build_imengine_table	1
%define build_imengine_socket	1
%define build_gtk2_immodule	1
%define build_scim_setup        1
%define build_panel_gtk         1
%define build_gtk_utils         1
%setup -q -n %{name}-%{version}
%patch0 -p1
%patch1 -p1
%patch2 -p1 -b .default-languages
%if %suse_version == 810
pushd /
%patch100 -p0 -b .gettextize
popd
%endif
find . -type f | xargs chmod u+w
UTF_8_LOCALES=$(locale -a | grep utf8 | perl -p -e "s/utf8/UTF-8/; s/\n/,/; " | perl -p -e "s/,$//")
perl -pi -e "s/\/SupportedUnicodeLocales =.*/\/SupportedUnicodeLocales = $UTF_8_LOCALES/"  ./configs/global
perl -pi -e "s/en_US.UTF-8/$UTF_8_LOCALES/"  ./configs/scim.schemas

%build
libtoolize --force
autoreconf -I /opt/gnome/share/aclocal --force --install --verbose
if [ ! -f po/Makevars -a -f po/Makevars.template ] ; then
    cp po/Makevars.template po/Makevars
fi
export CFLAGS="$RPM_OPT_FLAGS -fno-strict-aliasing"
export CXXFLAGS="$RPM_OPT_FLAGS -fno-strict-aliasing"
#export CFLAGS="-g -O0 -fno-strict-aliasing"
#export CXXFLAGS="-g -O0 -fno-strict-aliasing"
./configure --prefix=/usr \
            --sysconfdir=%{_sysconfdir} \
            --libdir=%{_libdir} \
	    --libexecdir=%{_libdir}/scim-1.0 \
            --mandir=%{_mandir} \
            --infodir=%{_infodir} \
%if ! %{build_config_socket}
            --disable-config-socket \
%endif
%if ! %{build_config_gconf}
            --disable-config-gconf \
%endif
%if ! %{build_config_simple}
            --disable-config-simple \
%endif
%if ! %{build_frontend_x11}
           --disable-frontend-x11 \
%endif
%if ! %{build_frontend_socket}
           --disable-frontend-socket \
%endif
%if ! %{build_imengine_rawcode}
           --disable-im-rawcode \
%endif
%if ! %{build_imengine_table}
           --disable-im-table \
%endif
%if ! %{build_imengine_socket}
           --disable-im-socket \
%endif
%if ! %{build_gtk2_immodule}
           --disable-gtk2-immodule \
%endif
%if ! %{build_scim_setup}
           --disable-setup-ui \
%endif
            --disable-schemas-install \
            --enable-debug \
            --with-gconf-schema-file-dir=/etc/opt/gnome/gconf/schemas
make top_builddir=$(pwd)
# # build documentation:
# make -C docs html
# make -C docs/manual/zh_CN html

%install
[ "$RPM_BUILD_ROOT" != "/" ] && [ -d $RPM_BUILD_ROOT ] && rm -rf $RPM_BUILD_ROOT;
export GCONF_DISABLE_MAKEFILE_SCHEMA_INSTALL=1
make DESTDIR=${RPM_BUILD_ROOT} top_builddir=$(pwd) install
unset GCONF_DISABLE_MAKEFILE_SCHEMA_INSTALL
mkdir -p ${RPM_BUILD_ROOT}/%{_libdir}/scim-1.0/{Config,FrontEnd,IMEngine,SetupUI}
rm -f ${RPM_BUILD_ROOT}/%{_libdir}/scim-1.0/*/*/*.{a,la}
rm -f ${RPM_BUILD_ROOT}//opt/gnome/%_lib/gtk-2.0/immodules/im-scim.{a,la}
# install user manual
mkdir -p docs/dist/manual/zh_CN/figures/
cp -a docs/manual/zh_CN/user-manual.{html,xml} docs/dist/manual/zh_CN/
cp -a docs/manual/zh_CN/figures/*.png docs/dist/manual/zh_CN/figures/
%find_lang scim
%suse_update_desktop_file scim-setup System SystemSetup

%clean
[ "$RPM_BUILD_ROOT" != "/" ] && [ -d $RPM_BUILD_ROOT ] && rm -rf $RPM_BUILD_ROOT;

%post 
%run_ldconfig
%if %{build_config_gconf}
export GCONF_CONFIG_SOURCE=`opt/gnome/bin/gconftool-2 --get-default-source`
opt/gnome/bin/gconftool-2 --makefile-install-rule etc/opt/gnome/gconf/schemas/scim.schemas >/dev/null
%endif
%if %{build_gtk2_immodule}
# trigger run of SuSEconfig.gtk2 to register/unregister this input module
# by calling gtk-query-immodules-2.0:
touch var/adm/SuSEconfig/run-gtk
%endif

%postun 
%run_ldconfig
%if %{build_gtk2_immodule}
# trigger run of SuSEconfig.gtk2 to register/unregister this input module
# by calling gtk-query-immodules-2.0:
touch var/adm/SuSEconfig/run-gtk
%endif

%files -f scim.lang
%defattr(-, root, root)
%doc AUTHORS COPYING NEWS README ChangeLog TODO
%doc docs/dist/manual/zh_CN
%dir %{_sysconfdir}/scim
%dir %{_libdir}/scim-1.0
%dir %{_libdir}/scim-1.0/1.0.0
%dir %{_libdir}/scim-1.0/*/FrontEnd
%dir %{_libdir}/scim-1.0/*/IMEngine
%dir %{_libdir}/scim-1.0/*/Config
%dir %{_libdir}/scim-1.0/*/SetupUI
%dir %{_libdir}/scim-1.0/Config
%dir %{_libdir}/scim-1.0/FrontEnd
%dir %{_libdir}/scim-1.0/IMEngine
%dir %{_libdir}/scim-1.0/SetupUI
%dir %{_datadir}/scim
%dir %{_datadir}/scim/icons
%config %{_sysconfdir}/scim/global
%{_bindir}/scim
%{_bindir}/scim-config-agent
%{_libdir}/libscim*.so.*
%{_libdir}/scim-1.0/scim-launcher
%{_datadir}/scim/icons/keyboard.png
%{_datadir}/scim/icons/up.png
%{_datadir}/scim/icons/down.png
%{_datadir}/scim/icons/left.png
%{_datadir}/scim/icons/right.png
%{_datadir}/scim/icons/full-letter.png
%{_datadir}/scim/icons/half-letter.png
%{_datadir}/scim/icons/full-punct.png
%{_datadir}/scim/icons/half-punct.png
%{_datadir}/scim/icons/help.png
%{_datadir}/scim/icons/pin-up.png
%{_datadir}/scim/icons/pin-down.png
%{_datadir}/scim/icons/setup.png
%{_datadir}/scim/icons/trademark.png
%if %{build_scim_setup}
%{_bindir}/scim-setup
%{_datadir}/applications/scim-setup.desktop
%{_datadir}/control-center-2.0
%{_datadir}/control-center-2.0/capplets
%{_datadir}/control-center-2.0/capplets/scim-setup.desktop
%{_datadir}/pixmaps/scim-setup.png
%endif
%if %{build_panel_gtk}
%{_libdir}/scim-1.0/scim-panel-gtk
%if %{build_scim_setup}
%{_libdir}/scim-1.0/*/SetupUI/panel-gtk-setup.so
%endif
%endif
%if %{build_frontend_x11}
%{_libdir}/scim-1.0/*/FrontEnd/x11.so
%if %{build_scim_setup}
%{_libdir}/scim-1.0/*/SetupUI/x11-frontend-setup.so
%endif
%endif
%if %{build_imengine_rawcode}
%{_libdir}/scim-1.0/*/IMEngine/rawcode.so
%{_datadir}/scim/icons/rawcode.png
%endif
%if %{build_imengine_table}
%{_bindir}/scim-make-table
%{_libdir}/scim-1.0/*/IMEngine/table.so
%{_datadir}/scim/icons/table.png
%if %{build_scim_setup}
%{_libdir}/scim-1.0/*/SetupUI/table-imengine-setup.so
%endif
%endif
%if %{build_config_simple}
%config %{_sysconfdir}/scim/config
%{_libdir}/scim-1.0/*/Config/simple.so
%endif
%if %{build_imengine_socket}
%{_libdir}/scim-1.0/*/IMEngine/socket.so
%endif
%if %{build_frontend_socket}
%{_libdir}/scim-1.0/*/FrontEnd/socket.so
%endif
%if %{build_config_socket}
%{_libdir}/scim-1.0/*/Config/socket.so
%endif
%if %{build_gtk2_immodule}
/opt/gnome/%_lib/gtk-2.0/immodules/im-scim.so
%endif
%if %{build_config_gconf}
%config %{_sysconfdir}/opt/gnome/gconf/schemas/*
%{_libdir}/scim-1.0/*/Config/gconf.so
%endif

%files devel
%defattr(-, root, root)
%doc docs/html
%doc docs/developers
%{_libdir}/libscim*.so
%{_libdir}/lib*.*a
%{_libdir}/pkgconfig/*.pc
%{_includedir}/scim-1.0

%changelog -n scim
* Thu Dec 30 2004 - mfabian@suse.de
- update to 1.0.2.
- remove reduce-default-debug-output.patch (Zhe Su has implemented
  a better solution in 1.0.2 now).
* Mon Oct 04 2004 - mfabian@suse.de
- Bugzilla #46565: reduce default debug output of scim.
- Bugzilla #46365 comment #20: Set preedit caret when updating
  preedit string.
* Wed Sep 29 2004 - mfabian@suse.de
- make OnTheSpot input style the default for XIM.
* Tue Sep 21 2004 - mfabian@suse.de
- update to 1.0.1
- Added missing assignment for SCIM_BUILD_GTK_UTILS variable in
  configure.ac
- Call focus_out when turnning off input method in gtkimmodule.
- Fixed gtk2 binary compatibility issue. Now scim binary compiled
  against gtk2-2.2.x can be used with gtk2-2.4.x.
* Mon Sep 20 2004 - mfabian@suse.de
- add bugfix-patch received from author (Zhe Su).
- add "Requires: gtk2 >= 2.2.0, gtk2 < 2.4.0" for SuSE 9.1.
* Sat Sep 04 2004 - mfabian@suse.de
- make scim the default for ja, ko, zh_CN, zh_TW, and zh_HK
  when using GTK_IM_MODULE.
* Sat Sep 04 2004 - mfabian@suse.de
- update to 1.0.0.
* Fri Sep 03 2004 - mfabian@suse.de
- use "Control+space,Shift+space" as the default for
  /FrontEnd/Keys/Trigger instead of only "Control+space".
  Users of kinput2, ami, ... are used to Shift+Space and may
  not expect "Control+Space".
* Mon Aug 30 2004 - mfabian@suse.de
- update to 0.99.9.
  (German translations available now, startup problem in ~/.xim
  is fixed).
* Wed Aug 25 2004 - mfabian@suse.de
- update to 0.99.8.
- Bugzilla #44155: add /usr/bin/touch to PreReq:.
- enable all UTF-8 locales again in /etc/scim/global, this
  should work now, Zhe Su fixed a bug in IMdkit.
* Sat Aug 21 2004 - mfabian@suse.de
- add 64bit.patch received from Zhe Su to fix crash of scim-setup
  on x86_64 when clicking on the top-level items in the tree
  on the left side.
* Fri Aug 20 2004 - mfabian@suse.de
- update to 0.99.7.
* Wed Aug 18 2004 - mfabian@suse.de
- Bugzilla #43802: add 64bit.patch received from
  Zhe Su <zsu@novell.com> which fixes this bug.
* Fri Aug 13 2004 - mfabian@suse.de
- update to 0.99.6 final.
* Thu Aug 12 2004 - mfabian@suse.de
- update to 0.99.6 (CVS)
  (includes my 64bit.patch to fix the segmentation fault on x86_64)
* Thu Aug 05 2004 - mfabian@suse.de
- update to 0.99.2.
- merge scim-gtk2-immodule, scim-config-socket, scim-server-socket,
  scim-config-gconf, and scim-frontend-socket subpackages into
  scim and scim-devel (the upstream author made that change I
  think it's better that way too).
* Tue May 11 2004 - sbrabec@suse.cz
- PreReq moved to proper subpackage.
* Tue May 11 2004 - sbrabec@suse.cz
- Fixed gconftool-2 prerequirements.
* Tue Apr 27 2004 - mfabian@suse.de
- update to 0.9.6
- remove scim-0.9.1-fix.patch (included now).
- set text DOMAIN to "scim" to make the .mo files install correctly
- mv scim-im.so to /opt/gnome/%%_lib/gtk-2.0/immodules/im-scim.so
  instead of /opt/gnome/%%_lib/gtk-2.0/2.3.5/immodules/im-scim.so
* Fri Apr 02 2004 - mfabian@suse.de, zsu@novell.com
- add patch received by author which fixes a problem with the gtk
  help dialog.
* Wed Mar 10 2004 - sbrabec@suse.cz
- Fixed gconf schemas installation (#33114).
* Fri Feb 27 2004 - mfabian@suse.de
- don't enable all UTF-8 locales, unfortunately this still doesn't
  work.
* Thu Feb 26 2004 - mfabian@suse.de
- update to 0.9.1.
- remove max-config-line-length.patch, included upstream.
* Thu Feb 05 2004 - mfabian@suse.de
- don't make SCIM the default GTK input method for all languages,
  only for "zh".
- increase maximum allowed line length in config file.
* Tue Dec 09 2003 - mfabian@suse.de
- update to 0.8.2.
- remove subpackages scim-frontend-x11, scim-server-rawcode,
  scim-server-table, scim-config-simple (these are merged into
  the main scim packages upstream, it's better use the same
  structure in the SUSE packages as upstream).
* Wed Oct 22 2003 - sbrabec@suse.cz
- Use SuSE standard gconf schema installation.
* Fri Sep 05 2003 - mfabian@suse.de
- don't try to call in gtk-query-immodules-2.0 in %%post and
  %%postun, just trigger a run of SuSEconfig.gtk2
  which will then call gtk-query-immodules-2.0. See also
  Bugzilla #29417.
* Wed Aug 20 2003 - mfabian@suse.de
- remove "Requires: gconf2 >= 1.1.10"
* Fri Aug 15 2003 - adrian@suse.de
- add Categories
* Sun Aug 03 2003 - ro@suse.de
- gtk has been moved to /opt/gnome
* Mon Jul 14 2003 - sbrabec@suse.cz
- GNOME prefix change to /opt/gnome.
* Fri Jul 04 2003 - mfabian@suse.de
- new package: version 0.5.0.
- adapt .spec file for SuSE.
- remove scim-suite subpackage, it contains the same files as
  some other sub-packages and is only intended to make it easier
  for the user to install the basic stuff to use SCIM without
  having to think which sub-packages to install. But this can be
  done by language specific selections, having an extra package
  duplicating contents of other packages just wastes space on
  the CDs.
* Thu Jun 19 2003 - James Su <suzhe@turbolinux.com.cn>
- updated to include scim-setup and its modules.
* Thu Apr 03 2003 - James Su <suzhe@turbolinux.com.cn>
- added suite package, which includes all necessary components of SCIM.
* Tue Mar 25 2003 - James Su <suzhe@turbolinux.com.cn>
- updated to v0.4.0
* Wed Feb 26 2003 - James Su <suzhe@turbolinux.com.cn>
- implemented dynamic adjust feature for generic table module.
- fixed key handling bug in generic table module.
* Mon Feb 10 2003 - James Su <suzhe@turbolinux.com.cn>
- Replaced highlight_start and highlight_end in scim_server
  and scim_frontend with AttributeList (scim_attributes.h)
- Moved icons/* to data/icons and gtkstringview.* to
  utils/
* Thu Jan 02 2003 - James Su <suzhe@turbolinux.com.cn>
- updated configure.ac and Makefile.am
- ready to release 0.3.0
* Tue Nov 12 2002 - James Su <suzhe@turbolinux.com.cn>
- merged signal system from libinti.
- implemented namespace scim.
- implemented referenced object.
- version 0.3.0
* Tue Nov 05 2002 - James Su <suzhe@turbolinux.com.cn>
- minor fixes for table IM module.
* Mon Nov 04 2002 - James Su <suzhe@turbolinux.com.cn>
- More IMdkit memory leak fixes.
- Table input method bugfixes.
- version 0.2.2
* Fri Nov 01 2002 - James Su <suzhe@turbolinux.com.cn>
- improved table input method.
- actually fixed the memleaks within IMdkit.
- pumped the version to 0.2.1
* Thu Oct 31 2002 - James Su <suzhe@turbolinux.com.cn>
- fixed some memory leaks in IMdkit
- reduced memory usage.
- upgraded to libtool-1.4.3
* Tue Oct 29 2002 - James Su <suzhe@turbolinux.com.cn>
- finished Generic Table input server module.
- fixed several bugs in scim-lib.
* Thu Oct 10 2002 - James Su <suzhe@turbolinux.com.cn>
- used gettext to support i18n message.
- added release info to lib name.
* Mon Sep 30 2002 - James Su <suzhe@turbolinux.com.cn>
- version 0.1.4
- added Embedded Lookup Table style into X11 FrontEnd.
- use wchar_t instead of unsigned long if __STDC_ISO_10646__ defined.
* Sun Sep 22 2002 - James Su <suzhe@turbolinux.com.cn>
- version 0.1.3
- config button of X11 FrontEnd was disabled.
* Fri Sep 06 2002 - James Su <suzhe@turbolinux.com.cn>
- simplified the utilities and lookup table interface.
* Wed Aug 21 2002 - James Su <suzhe@turbolinux.com.cn>
- version 0.1.2
- added configuration options to disable modules.
- enhanced X11 FrontEnd.
* Sun Aug 11 2002 - James Su <suzhe@turbolinux.com.cn>
- version 0.1.1
- X11 FrontEnd was enhanced.
* Sat Aug 10 2002 - James Su <suzhe@turbolinux.com.cn>
- version 0.1.0
- many bugfixes.
- Help window of X11 FrontEnd was implemented.
- scim can exit cleanly.
* Fri Aug 02 2002 - James Su <suzhe@turbolinux.com.cn>
- SCIM 0.0.13.
- Minor bugfixes.
* Mon Jul 29 2002 - James Su <suzhe@turbolinux.com.cn>
- SCIM 0.0.12.
- Minor bugfixes.
* Sun Jul 28 2002 - James Su <suzhe@turbolinux.com.cn>
- SCIM 0.0.11.
- Minor bugfixes.
* Sun Jul 21 2002 - James Su <suzhe@turbolinux.com.cn>
- SCIM 0.0.10.
- Added Simple Config module.
* Sat Jun 22 2002 - James Su <suzhe@turbolinux.com.cn>
- first public release of SCIM.
